
string getAlterationName(const string &in alteration, const string &in activityname) {
    if (false) {
    } else if (alteration == 'bettermixed') {
        return 'Better Mixed';
    } else if (alteration == 'fragile100%') {
        return '100% Fragile';
    } else if (alteration == 'cruise') {
        return 'Cruise Control';
    } else if (alteration == 'rngboost') {
        return 'RNG Booster';
    } else if (alteration == 'back1') {
        return '1Back';
    } else if (alteration == 'forwards1') {
        return '1Back';
    } else if (alteration == 'down1') {
        return '1Down';
    } else if (alteration == 'left1') {
        return '1Left';
    } else if (alteration == 'right1') {
        return '1Right';
    } else if (alteration == 'up1') {
        return '1Up';
    } else if (alteration == 'up2') {
        return '2Up';
    } else if (alteration == 'betterreverse') {
        return 'Better Reverse';
    } else if (alteration == 'magna') {
        return 'Better Reverse';
    } else if (alteration == 'cp1 end') {
        return 'CP1 is End';
    } else if (alteration == 'sky finish') {
        return 'Sky is the Finish';
    } else if (alteration == 'there&back') {
        return 'There and Back';
    } else if (alteration == 'boomerang') {
        return 'There and Back';
    } else if (alteration == 'yeptreepuzzle') {
        return 'YEP Tree Puzzle';
    } else if (alteration == 'wetplastic') { // snow only
        return 'Wet Plastic';
    } else if (alteration == 'undrwater') { // rally only
        return 'Underwater';
    } else if (alteration == 'ice rev reactor') {
        return 'Ice Reverse Reactor';
    } else if (alteration == 'iceshort') {
        return 'Ice Short';
    } else if (alteration == 'magnet rev') {
        return 'Magnet Reverse';
    } else if (alteration == 'sky fin rev') {
        return 'Sky is the Finish Reverse';
    } else if (alteration == 'sw2u1l_cp_f2d1r') {
        return 'Start Water 2 Up 1 Left, Checkpoints Unlinked, Finish 2 Down 1 Right';
    } else if (alteration == 'nderwater reverse') {
        return 'Underwater Reverse';
    } else if (alteration == 'unw reverse') {
        return 'Underwater Reverse';
    } else if (alteration == 'weticywood') {
        return 'Wet Icy Wood';
    } else if (alteration == 'weticywood100%') {
        return '100% Wet Icy Wood';
    } else if (alteration == 'weticywood pure') {
        return 'Pure Wet Icy Wood';
    } else if (alteration == 'pureweticywood') {
        return 'Pure Wet Icy Wood';
    } else if (alteration == 'yeetandmpuzzle') {
        return 'Yeet Random Puzzle';
    } else if (alteration == 'yeetreverse') {
        return 'Yeet Reverse';
    } else if (alteration == 'cp/boost') {
        return 'CPs & Boosters Swapped';
    } else if (alteration == 'cpfull') {
        return 'Checkpointfull';
    } else if (alteration == 'cpless°') {
        return 'Checkpointless';
    } else if (alteration == 'cplink') {
        return 'Checkpoints Linked';
    } else if (alteration == 'cps 90°') {
        return 'Checkpoints Rotated 90°';
    } else if (alteration == 'rotated') {
        return 'Rotated'; // maybe checkpoints 90 as well
    } else if (alteration == 'select del') {
        return 'Selection Rotated 90° and Deleted';
    } else if (alteration == 'start 1 down') {
        return 'Start 1Down';
    } else if (alteration == 'sttf') {
        return 'Straight to the Finish';
    } else if (alteration == '训练') {
        return '训练 [Chinese]';
    } else if (alteration == '夏季赛') {
        return '夏季赛 [Chinese]';
    } else if (alteration == '秋季') {
        return '秋季 [Chinese]';
    }

    int pos = activityname.ToLower().IndexOf(alteration);
    if (pos == -1) {
        return alteration.SubStr(0,1).ToUpper() + alteration.SubStr(1);
    } else {
        return activityname.SubStr(pos, alteration.Length);
    }
}

uint getSpecialMapNumber(Map@ map) {
    if (map.name == 'S13-') {
        return 23;
    }
    uint number = 0;
    uint numfound = 0;
    for (uint i = 1; i <= 25; i++) {
        if (map.simpleName.Contains('_-_' + Text::Format('%02d', i)) ||
            map.simpleName.Contains('- Replay ' + Text::Format('%02d', i)) ||
            map.simpleName.Contains('- There&Back ' + Text::Format('%02d', i)) ||
            map.simpleName.Contains('Icy RR Winter 2023 ' + Text::Format('%02d', i)) ||
            map.simpleName.Contains('2D-Summer2022-' + Text::Format('%02d', i)) ||
            map.simpleName.Contains('Supersized ' + Text::Format('%02d', i)) ||
            map.simpleName.Contains(Text::Format('%02d', i) + ' Big') ||
            map.simpleName.Contains(Text::Format('%02d', i) + ' - Tilted') ||
            map.simpleName.Contains(Text::Format('%02d', i) + ' (BLIND)') ||
            map.simpleName.Contains(Text::Format('%02d', i) + ' (Mirror)') ||
            map.simpleName.Contains('Super' + Text::Format('%02d', i))) {
                number = i;
                numfound += 1;
        }
    }
    if (numfound == 1) {
        return number;
    } else if (numfound > 1) {
        if (debugPrint) {print('invalid map name 2: ' + map.simpleName);}
        return 0;
    }
    if (map.simpleName == 'Spring 2024 09 Supersized') {
        return 9;
    } else if (map.simpleName == 'Fall 2022 poolhunter -13') {
        return 13;
    } else if (map.simpleName == 'Fall 2022 poolhunter Featuring TnTree') {
        return 14;
    } else if (map.simpleName == 'winter 2020 01 slowmo') {
        return 1;
    } else if (map.simpleName == ' Icy Spring 2021 - 9') {
        return 9;
    }

    return 0;
}
uint getDuplicateMapNumber(Map@ map) {
    uint number = 0;
    uint numfound = 0;
    for (uint i = 1; i <= 25; i++) {
        if (map.simpleName.Contains(' - ' + Text::Format('%02d', i) + ' - 08')) {
            number = i;
            numfound += 1;
        }
    }
    if (numfound == 1) {
        return number;
    } else if (numfound > 1) {
        if (debugPrint) {print('invalid map name 3: ' + map.simpleName);}
        return 0;
    }
    return 0;
}

uint getSnowDiscoveryNumber(const string &in mapname) {
    if (mapname.Contains('snowisback')) {
        return 1;
    }
    if (mapname.Contains('icyhills')) {
        return 2;
    }
    if (mapname.Contains('snowglider')) {
        return 3;
    }
    if (mapname.Contains('woodforce')) {
        return 4;
    }
    if (mapname.Contains('wetwood')) {
        return 5;
    }
    if (mapname.Contains('breakorslide')) {
        return 6;
    }
    if (mapname.Contains('icysnow')) {
        return 7;
    }
    if (mapname.Contains('woodyslalom')) {
        return 8;
    }
    if (mapname.Contains('temple')) {
        return 9;
    }
    if (mapname.Contains('slippysnow')) {
        return 10;
    }
    if (mapname.Contains('hairpins')) {
        return 11;
    }
    if (mapname.Contains('rock&revel')) {
        return 12;
    }
    if (mapname.Contains('iamspeed')) {
        return 13;
    }
    if (mapname.Contains('boblover')) {
        return 14;
    }
    if (mapname.Contains('summersnow')) {
        return 15;
    }
    if (debugPrint) {print('invalid discovery map name: ' + mapname);}
    return 0;
}

uint getRallyDiscoveryNumber(const string &in mapname) {
    if (mapname.Contains('rallyisback')) {
        return 1;
    }
    if (mapname.Contains('rallyb1 reloaded')) {
        return 2;
    }
    if (mapname.Contains('bumpyrally')) {
        return 3;
    }
    if (mapname.Contains('castlewall')) {
        return 4;
    }
    if (mapname.Contains('grippyrally')) {
        return 5;
    }
    if (mapname.Contains('nightwatch')) {
        return 6;
    }
    if (mapname.Contains('newslopes')) {
        return 7;
    }
    if (mapname.Contains('greenstage')) {
        return 8;
    }
    if (mapname.Contains('rallyc1 reloaded')) {
        return 9;
    }
    if (mapname.Contains('2laps2cars')) {
        return 10;
    }
    if (mapname.Contains('ralleigh')) {
        return 11;
    }
    if (mapname.Contains('dirt2024')) {
        return 12;
    }
    if (mapname.Contains('rallyonroad')) {
        return 13;
    }
    if (mapname.Contains('transformania')) {
        return 14;
    }
    if (mapname.Contains('deepease')) {
        return 15;
    }
    if (mapname.Contains('classicrally')) {
        return 16;
    }
    if (mapname.Contains('radium')) {
        return 17;
    }
    if (mapname.Contains('wetrally')) {
        return 18;
    }
    if (mapname.Contains('frostymorning')) {
        return 19;
    }
    if (mapname.Contains('rastic')) {
        return 20;
    }
    if (mapname.Contains('offroad')) {
        return 21;
    }
    if (mapname.Contains('mixedstage')) {
        return 22;
    }
    if (mapname.Contains('snolly')) {
        return 23;
    }
    if (mapname.Contains('stally')) {
        // error in Rally Discovery Ice
        return 23;
    }
    if (mapname.Contains('iamspeed2')) {
        return 24;
    }
    if (mapname.Contains('powerstage')) {
        return 25;
    }
    if (debugPrint) {print('invalid discovery map name: ' + mapname);}
    return 0;
}

uint getDesertDiscoveryNumber(const string &in mapname) {
    if (mapname.Contains('desertisback')) {
        return 1;
    }
    if (mapname.Contains('platformjourney')) {
        return 2;
    }
    if (mapname.Contains('wiggle')) {
        return 3;
    }
    if (mapname.Contains('desertonroad')) {
        return 4;
    }
    if (mapname.Contains('originals')) {
        return 5;
    }
    if (mapname.Contains('newloops')) {
        return 6;
    }
    if (mapname.Contains('desertc1reloaded')) {
        return 7;
    }
    if (mapname.Contains('a08lover')) {
        return 8;
    }
    if (mapname.Contains('desertdirt')) {
        return 9;
    }
    if (mapname.Contains('2cars2laps')) {
        return 10;
    }
    if (mapname.Contains('grassydesert')) {
        return 11;
    }
    if (mapname.Contains('destech')) {
        return 12;
    }
    if (mapname.Contains('desertcastle')) {
        return 13;
    }
    if (mapname.Contains('plasert')) {
        return 14;
    }
    if (mapname.Contains('dice')) {
        return 15;
    }
    if (mapname.Contains('woodydesert')) {
        return 16;
    }
    if (mapname.Contains('narrow')) {
        return 17;
    }
    if (mapname.Contains('americanspeed')) {
        return 18;
    }
    if (mapname.Contains('halfpipes')) {
        return 19;
    }
    if (mapname.Contains('desertcity')) {
        return 20;
    }
    if (mapname.Contains('wetdesert')) {
        return 21;
    }
    if (mapname.Contains('2wheelers')) {
        return 22;
    }
    if (mapname.Contains('desertleague')) {
        return 23;
    }
    if (mapname.Contains('deserpg')) {
        return 24;
    }
    if (mapname.Contains('desertmaster')) {
        return 25;
    }
    if (debugPrint) {print('invalid discovery map name: ' + mapname);}
    return 0;
}

uint getStuntDiscoveryNumber(const string &in mapname) {
    if (mapname.Contains('stuntisback')) {
        return 1;
    }
    if (mapname.Contains('simpleflips')) {
        return 2;
    }
    if (mapname.Contains('arena')) {
        return 3;
    }
    if (mapname.Contains('superpipe')) {
        return 4;
    }
    if (mapname.Contains('stunt4ever')) {
        return 5;
    }
    if (mapname.Contains('freedom')) {
        return 6;
    }
    if (mapname.Contains('originalpark')) {
        return 7;
    }
    if (mapname.Contains('a08stunter')) {
        return 8;
    }
    if (mapname.Contains('lasagna')) {
        return 9;
    }
    if (mapname.Contains('giveme5')) {
        return 10;
    }
    if (mapname.Contains('airmania')) {
        return 11;
    }
    if (mapname.Contains('bumpersparadise')) {
        return 12;
    }
    if (mapname.Contains('platformedges')) {
        return 13;
    }
    if (mapname.Contains('moustache')) {
        return 14;
    }
    if (mapname.Contains('redalert')) {
        return 15;
    }
    if (mapname.Contains('roundabout')) {
        return 16;
    }
    if (mapname.Contains('hiking')) {
        return 17;
    }
    if (mapname.Contains('cibusfanaticus')) {
        return 18;
    }
    if (mapname.Contains('snowspinning')) {
        return 19;
    }
    if (mapname.Contains('frikandelbroodje')) {
        return 20;
    }
    if (mapname.Contains('highspeed')) {
        return 21;
    }
    if (mapname.Contains('deserticstunts')) {
        return 22;
    }
    if (mapname.Contains('foundry')) {
        return 23;
    }
    if (mapname.Contains('stuntcity')) {
        return 24;
    }
    if (mapname.Contains('scatterpark')) {
        return 25;
    }
    if (debugPrint) {print('invalid discovery map name: ' + mapname);}
    return 0;
}

uint getPlatformDiscoveryNumber(const string &in mapname) {
    if (mapname.Contains('pinkplatform')) {
        return 1;
    }
    if (mapname.Contains('tangerine')) {
        return 2;
    }
    if (mapname.Contains('lemonpeaks')) {
        return 3;
    }
    if (mapname.Contains('orangehills')) {
        return 4;
    }
    if (mapname.Contains('pipeline')) {
        return 5;
    }
    if (mapname.Contains('lagooning')) {
        return 6;
    }
    if (mapname.Contains('scarlet summit')) {
        return 7;
    }
    if (mapname.Contains('glacial plunge')) {
        return 8;
    }
    if (mapname.Contains('primula')) {
        return 9;
    }
    if (mapname.Contains('just do it')) {
        return 10;
    }
    if (mapname.Contains('bulrush')) {
        return 11;
    }
    if (mapname.Contains('cobalt cove')) {
        return 12;
    }
    if (mapname.Contains('caramel')) {
        return 13;
    }
    if (mapname.Contains('island hopping')) {
        return 14;
    }
    if (mapname.Contains('padauk')) {
        return 15;
    }
    if (mapname.Contains('maple mist')) {
        return 16;
    }
    if (mapname.Contains('coffee')) {
        return 17;
    }
    if (mapname.Contains('meep mip')) {
        return 18;
    }
    if (mapname.Contains('backstroke')) {
        return 19;
    }
    if (mapname.Contains('hypothermic')) {
        return 20;
    }
    if (mapname.Contains('ceramic')) {
        return 21;
    }
    if (mapname.Contains('atfo')) {
        return 22;
    }
    if (mapname.Contains('deja vu')) {
        return 23;
    }
    if (mapname.Contains('dance of the sugar plum fairy')) {
        return 24;
    }
    if (mapname.Contains('tothepink')) {
        return 25;
    }
    if (debugPrint) {print('invalid discovery map name: ' + mapname);}
    return 0;
}

uint getRoyalNumber(const string &in mapname) {
    if (mapname.Contains('elevatord')) {
        return 1;
    }
    if (mapname.Contains('colorpool')) {
        return 2;
    }
    if (mapname.Contains('runthewater')) {
        return 3;
    }
    if (mapname.Contains('hittheroads')) {
        return 4;
    }
    if (mapname.Contains('jumpinsplash')) {
        return 5;
    }
    if (mapname.Contains('neverest')) {
        return 6;
    }
    if (mapname.Contains('notechlogic')) {
        return 7;
    }
    if (mapname.Contains('thelarotabyn')) {
        return 8;
    }
    if (mapname.Contains('riseform')) {
        return 9;
    }
    if (mapname.Contains('boosthour')) {
        return 10;
    }
    if (mapname.Contains('summertube')) {
        return 11;
    }
    if (mapname.Contains('waterfall')) {
        return 12;
    }
    if (mapname.Contains('orienticion')) {
        return 13;
    }
    if (mapname.Contains('wetplastic')) {
        return 14;
    }
    if (mapname.Contains('drownedroad')) {
        return 15;
    }
    if (mapname.Contains('deserticslalom')) {
        return 16;
    }
    if (mapname.Contains('oasispark')) {
        return 17;
    }
    if (mapname.Contains('coloredpipes')) {
        return 18;
    }
    if (debugPrint) {print('invalid royal map name: ' + mapname);}
    return 0;
}

// map names that are intentionally invalid (I cba to check this just for debug-print xdd)
/*
idk
Training - White Combined
Training - Green Combined
Training - Blue Combined
Training - Red Combined
Training - Black Combined
Training - Rainbow Combined
wet stastic
White BOSS Winter 2024
Green BOSS Winter 2024
Blue BOSS Winter 2024
Red BOSS Winter 2024
Black BOSS Winter 2024
Winter 2024 - Section 1 Joined
Winter 2024 - Section 2 Joined
Winter 2024 - Section 3 Joined
Winter 2024 - Section 4 Joined
Winter 2024 - Section 5 Joined
Winter 2024 - Section 6 Joined
Winter 2024 - Section 7 Joined
Winter 2024 - Section 8 Joined
Winter 2024 - Section 9 Joined
Winter 2024 - Section 10 Joined
Winter 2024 - Section 11 Joined
Winter 2024 - Section 12 Joined
Winter 2024 - Section 13 Joined
Winter 2024 - Section 14 Joined
Winter 2024 - Section 15 Joined
Winter 2024 - Last Section Joined
Fall 2023 - Section 1 Joined
Fall 2023 - Section 2 Joined
Fall 2023 - Section 3 Joined
Fall 2023 - Section 4 Joined
Fall 2023 - Section 5 Joined
Fall 2023 - Section 6 Joined
Fall 2023 - Section 7 Joined
Fall 2023 - Section 8 Joined
Fall 2023 - Section 9 Joined
Fall 2023 - Section 10 Joined
Fall 2023 - Section 11 Joined
Fall 2023 - Section 12 Joined
Fall 2023 - Section 13 Joined
Fall 2023 - Section 14 Joined
Fall 2023 - Section 15 Joined
Fall 2023 - Section 16 Joined
Fall 2023 - Section 17 Joined
Fall 2023 - Last Section Joined
White BOSS - Summer'23
Green BOSS - Summer'23
Blue BOSS - Summer'23
Red BOSS - Summer'23
Black BOSS - Summer'23
Summer 2023 - Section 1 Joined
Summer 2023 - Section 2 Joined
Summer 2023 - Section 3 Joined
Summer 2023 - Section 4 Joined
Summer 2023 - Section 5 Joined
Summer 2023 - Section 6 Joined
Summer 2023 - Section 7 Joined
Summer 2023 - Section 8 Joined
Summer 2023 - Section 9 Joined
Summer 2023 - Section 10 Joined
Summer 2023 - Section 11 Joined
Summer 2023 - Section 12 Joined
Summer 2023 - Section 13 Joined
Summer 2023 - Last Section Joined
BOSS White of Spring 2023
BOSS Green of Spring 2023
BOSS Blue of Spring 2023
BOSS Red of Spring 2023
BOSS Black of Spring 2023
Spring 2023 - Section 1 Joined (All Starts)
Spring 2023 - Section 2 Joined
Spring 2023 - Section 3 Joined
Spring 2023 - Section 4 Joined
Spring 2023 - Section 5 Joined
Spring 2023 - Section 6 Joined
Spring 2023 - Section 7 Joined
Spring 2023 - Section 8 Joined
Spring 2023 - Section 9 Joined
Spring 2023 - Section 10 Joined
Spring 2023 - Section 11 Joined
Spring 2023 - Last Section Joined (All Ends)
PLACEHOLDER 04
Winter 2022 - White Combined
Winter 2022 - Green Combined
Winter 2022 - Blue Combined
Winter 2022 - Red Combined
Winter 2022 - Black Combined
Winter 2022 -15 - Glider
Trash map
Fall 2021 - White Combined
Fall 2021 - Green Combined
Fall 2021 - Blue Combined
Fall 2021 - Red Combined
Fall 2021 - Black Combined
Summer 2021 - White Combined
Summer 2021 - Green Combined
Summer 2021 - Blue combined
Summer 2021 - Red Combined
Summer 2021 - Black Combined
final boss
Déjà vu
the fatal ending
*/